#include "ti83+Asm.inc"

.org $4000

;ID
#define FA9E5h

EXT_APP = 1                         ; Est definio  preciso para todas as aplicaes

; Est  a area definico da aplicao,  precisa para todas as aplicaes.

 .db $80, $0F                       ; Campo: Comprimento do programa
 .db 0, 0, 0, 0                     ; Comprimento = 0 (N/A para apps no assinadas)

#ifdef SIGN_APP
 .db $80, $13                       ; Campo: Tipo de Programa
 .db $FA9E5                         ; Tipo = Desenvolvimento do ID
#else
 .db $80, $12                       ; Campo: Tipo de Programa
 .db $01,$04                        ; Tipo = Compartilhado, TI-83+
#endif

 .db $80, $21                       ; Campo: App ID
 .db 1                              ; Id = 1
 .db $80, $31                       ; Campo: Construir App
 .db 1                              ; Construir = 1
 .db $80, $48                       ; Campo: Nome da App
 .db "FreitzOS"                     ; Campo -- Deve ser de 8 caracteres e no pode ultrapassar este
 .db $80, $81                       ; Campo: Paginas da App
 .db 1                              ; App Paginas = 1
 .db $80, $90                       ; Sem ecra intermitente
 .db $03, $26, $09, $04, $04, $6f, $1b, $80             ; Campo: Data- 5/12/1999
 .db $02, $0d, $40, $a1, $6b, $99, $f6, $59, $bc, $67   ; Assinatura encriptada da TI
 .db $f5, $85, $9c, $09, $6c, $0f, $b4, $03, $9b, $c9
 .db $03, $32, $2c, $e0, $03, $20, $e3, $2c, $f4, $2d 
 .db $73, $b4, $27, $c4, $a0, $72, $54, $b9, $ea, $7c 
 .db $3b, $aa, $16, $f6, $77, $83, $7a, $ee, $1a, $d4 
 .db $42, $4c, $6b, $8b, $13, $1f, $bb, $93, $8b, $fc 
 .db $19, $1c, $3c, $ec, $4d, $e5, $75
 .db $80, $7f                       ; Campo: Comprimento de imagem do programa
 .db   0, 0, 0, 0                   ; Comprimento = 0, N/A
 .db   0, 0, 0, 0                   ; Reservado
 .db   0, 0, 0, 0                   ; Reservado
 .db   0, 0, 0, 0                   ; Reservado
 .db   0, 0, 0                      ; Reservado
#ifndef SIGN_APP
 .db 0      ; add another pad byte if using only 2-byte keyfile
#endif

;Version english.
;-----------------------------------------------------------------------------------------------------------------------
;Mode 1
;-----------------------------------------------------------------------------------------------------------------------
;Desactive the ON key.
F_Mode_1_Desactivate_ON_key:
    b_call  _ClrScrnFull
    ld  hl,Text
    xor a
    ld  (curCol),a
    ld  (curRow),a
    call    PutSApp
    b_call  _GetKey
    res onInterrupt,(IY+onFlags)
;Erase the SaveScreeen.
F_Mode_1_Erase_SaveSScreen:
    b_call  _GrBufClr
    ld  hl,plotSScreen
    ld  de,saveSScreen
    push    hl          ;------------------------------------------->> Save XX, 0001
    ld  bc,768d
    ldir
;Show the apresentation image.
F_Mode_1_Show_Image_FrtzOS:
    ld  hl,FreitazOS_Imagem
    pop de              ;------------------------------------------->> Load XX, 0001
    ld  bc,768d
    ldir
    b_call  _GrBufCpy
    b_call  _GetKey
;Create a appVar geral if not created.
F_Mode_1_Create_AppVar_FrtzOS    
    ld  hl,T_AppVar_Geral
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym  
    call    c,Create_AppVar_Geral
    ld  a,b
    cp  0   \   jr  z,F_Mode_1_LogOn
    b_call  _Arc_Unarc
;LogOn of FreitazOS.
F_Mode_1_LogOn:
    ld  hl,T_AppVar_Geral
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
;Verific if is the correct appVar.    
    ex  de,hl
    inc hl  \   inc hl
    ld  a,(hl)  \   cp  99h \   jp  nz,Exit_Aplication_2    \   inc hl
    ld  a,(hl)  \   cp  99h \   jp  nz,Exit_Aplication_2    \   inc hl
;Insert in a buffer the data to display the menu of LogOn.    
    ld  de,Nr_Utilizadores
    ld  bc,17d
    ldir
;Menu of LogOn.
    call    LogOn_FrtzOS
    ld  a,(Utilizador_Activo)
    ld  hl,T_AppVar_Nm1 \   cp  1   \   jr  z,F_Mode_2_User_Load
    ld  hl,T_AppVar_Nm2
;Load a AppVar of User, if not created, create.
F_Mode_2_User_Load:
    push    hl          ;------------------------------------------->> Save XX, 0002
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    call    c,Criar_AppVar_Utiliz
    ld  a,b
    cp  0   \   jr  z,F_Mode_2_Check_User_Ready_Mode_2
    b_call  _Arc_Unarc
;Made a check to the AppVar of user if it's the correct, and prepare the system to enter in Mode 2.
F_Mode_2_Check_User_Ready_Mode_2
    pop hl              ;------------------------------------------->> Load XX, 0002
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    ex  de,hl
    inc hl  \   inc hl
    ld  a,(hl)  \   cp  99h \   jp  nz,Exit_Aplication  \   inc hl
    ld  a,(hl)  \   cp  99h \   jp  nz,Exit_Aplication
    ld  (Apontador_AppVar_Utiliz),hl
;End of Mode 1
;Bytes:152
;-----------------------------------------------------------------------------------------------------------------------
;Mode 2
;-----------------------------------------------------------------------------------------------------------------------     
F_Mode_2_Activate:;F_Modo_2_Ambiente_De_Trabalho_Activar
;Clear Matriz of Icons in this mode.
    res plotLoc,(IY+plotFlags)
    xor a       \   ld  hl,Matriz_Amb_Icone_1
    ld  (hl),a  \   ld  de,Matriz_Amb_Icone_1+1
    ld  bc,19d
    ldir
    ld  a,99h
    ld  (Matriz_Amb_Icone_1),a
    ld  (Matriz_Amb_Icone_10),a
    ld  hl,99h*256+00h
    ld  (Janela_Actual),hl
;Draw in plotSScreen buffer the tools bar.
    b_call  _ClrScrnFull
    b_call  _GrBufClr
    ld  hl,(Apontador_AppVar_Utiliz)    \   inc hl
    ld  a,(hl)
    ld  (Posicao_Iniciar),a
    call    Desenhar_Barra_De_Ferramentas
;Prepare to put in plotSScreen Buffer a the icon MYTI, and insert them.
    ld  hl,I_Icon_MyTI
    ld  de,Matriz_II_Imagem
    ld  bc,34d
    push    de          ;------------------------------------------->> Save XX, 0003
    push    bc          ;------------------------------------------->> Save XX, 0004
    ldir    
    ld  hl,T_MyTI
    ld  bc,4d
    ldir
    ld  b,1d
    call    Inserir_Icone
;Prepare to put in plotSScreen Buffer a the icon RECX, and insert them.    
    ld  hl,I_Icon_Reciclagem
    pop bc              ;------------------------------------------->> load XX, 0004
    pop de              ;------------------------------------------->> Load XX, 0003
    ldir
    ld  hl,T_Reciclagem
    ld  bc,4d
    ldir
    ld  b,10d
    call    Inserir_Icone
;Find in AppVar the Icones, prepare the matriz of mode.
    ld  hl,99h*256+00h
    call    Procurar_Icones   
    ld  b,8d
    ld  hl,Matriz_Amb_Icone_2
    call    F_Mode_2_5_Refresh_Matriz
    ;Inserir configuracoes de ScreenSaver 
    ld  a,(Janelas_Minimizadas)
    cp  0
    call    nz,F_Mode_2_Apresentation_Of_Windows_Minimizates
;Prepare the system to iniciate the mouse, and general routine of mode 2
    xor a       \   ld  (Interrupcao_Rato),a    \   ld  (Icone_Selecionado),a
    inc a       \   ld  (Amb_Iniciar_Pastas_Pgrm),a
    ld  a,46d   \   ld  (XPos_Rato),a
    ld  a,31d   \   ld  (YPos_Rato),a
F_Mode_2_General_Routine:;F_Modo_2_Rotina_Amb
    call    Rato_Windows
    cp  1   \   jp  z,F_Mode_2_2nd_Press
    cp  2   \   jp  z,F_Mode_2_Alpha_Press;F_Modo_2_Alpha_Pressionado
    cp  3   \   jp  z,F_Mode_2_Enter_Press;F_Modo_2_Enter_Pressionado
    ;...Savescreen
    jr  F_Mode_2_General_Routine
F_Mode_2_Insert_Image_Icon:
;HL -> Pointer of icon image
    ld  hl,I_Icon_Pastas    \   cp  1   \   ret z
    ld  hl,I_Icon_Desconhecido
    ret  
F_Mode_2_Apresentation_Of_Windows_Minimizates:;F_Modo_2_Apresentar_Janelas_Minimizadas 
;Save the saveSScreen
    ld  hl,saveSScreen
    ld  de,OP1+2
    ld  bc,200d
    ldir   
;See the position of "Iniciar" and give the coordenates to draw the signal of windows minimizates
    ld  a,(Posicao_Iniciar)
    ld  hl,1*256+35d    \   ld  de,4*256+72d    \   cp  1   \   jr  z,F_Mode_2_Draw_Windows_Minimizates
    ld  hl,59*256+35d   \   ld  de,62*256+72d   \   cp  2   \   jr  z,F_Mode_2_Draw_Windows_Minimizates
    ld  hl,34*256+1d    \   ld  de,40*256+4d    \   cp  3   \   jr  z,F_Mode_2_Draw_Windows_Minimizates
    ld  hl,34*256+91d   \   ld  de,40*256+94d
F_Mode_2_Draw_Windows_Minimizates
;Draw the signal of windows minimizates
    res plotLoc,(IY+plotFlags)
    b_call  _DrawRectBorderClear
;Restore the saveScreen    
    ld  hl,OP1+2
    ld  de,saveSScreen
    ld  bc,200d
    ldir
    ret
F_Mode_2_2nd_Press:;F_Modo_2_2nd_Pressionado
    call    F_Mode_2_5_Determinate_Cursor_Position
    ld  a,b
    cp  0ffh    \   jr  z,F_Mode_2_Verify_Shadow_Icon;F_Modo_2_Verificar
    cp  0       \   jp  z,Exit_Aplication
    cp  1       \   jp  z,F_Mode_3_Activate;F_Modo_3_Iniciar_Activar
    cp  2       \   jr  z,F_Mode_2_Maximate_Window;F_Modo_2_Janelas_Minimizadas
    cp  11d     \   call  nc,F_Mode_2_5_Select_Icon;F_Modo_2_Selecionar_Icones
    jp  F_Mode_2_General_Routine
F_Mode_2_Verify_Shadow_Icon:
;Verify if a icon is select, if is, deselect them
    ld  a,(Icone_Selecionado)
    cp  0   \   jp  z,F_Mode_2_General_Routine
    call    F_Mode_2_5_Select_Deselect_Icon
    xor a
    ld  (Icone_Selecionado),a
    jp  F_Mode_2_General_Routine
F_Mode_2_Maximate_Window:
;Maximate a window
    ld  a,(Janelas_Minimizadas)
    push    af              ;------------------------------------------->> Save XX, 0009
    cp  0   \   jp  z,F_Mode_2_Activate
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Janelas_Minimizadas
    call    PutSApp
    ld  hl,Janela_M_1
    pop af                  ;------------------------------------------->> Load XX, 0009
    ld  b,a
    ld  a,1d    \   ld  (penCol_FrtzOS),a
    ld  a,10d   \   ld  (penRow_FrtzOS),a
F_Mode_2_Windows_Name_Wright:
;Wright a name of a window
    ld  a,(hl)  \   ld  d,a \   inc hl
    ld  a,(hl)  \   ld  e,a \   inc hl
    inc de  \   inc de
    inc de  \   inc de
    push    hl              ;------------------------------------------->> Save XX, 0010
    push    bc              ;------------------------------------------->> Save XX, 0011
    ex  de,hl
    ld  c,2d
    ld  b,c
    call    PutSS
    ld  a,(penRow_FrtzOS)   \   add a,5d    \   ld  (penRow_FrtzOS),a
    ld  a,1d    \   ld  (penCol_FrtzOS),a
    pop     bc              ;------------------------------------------->> Load XX, 0011
    pop     hl              ;------------------------------------------->> Load XX, 0010
    djnz    F_Mode_2_Windows_Name_Wright
    ld  hl,9*256+0  \   ld  de,13*256+16
    ld  a,1d        \   ld  (Janela_Escolhida),a
    call    F_Mode_2_Shadow_Text_Windows
F_Mode_2_Windows_Menu:
;Menu of window
    push    hl              ;------------------------------------------->> Save XX, 0012
    push    de              ;------------------------------------------->> Save XX, 0013   
    b_call  _GetKey
    pop     de              ;------------------------------------------->> Load XX, 0013
    pop     hl              ;------------------------------------------->> Load XX, 0012
    cp  kUp     \   jr  z,F_Mode_2_Windows_Cursor_Position_Up
    cp  kDown   \   jr  z,F_Mode_2_Windows_Cursor_Position_Down
    cp  kClear  \   jp  z,F_Mode_2_Activate
    cp  kEnter  \   jr  z,F_Mode_2_Windows_Maximate_Select
    jr  F_Mode_2_Windows_Menu    
F_Mode_2_Windows_Cursor_Position_Up:
;The select cursor moves to up
    ld  a,(Janela_Escolhida)    \   cp  1   \   jr  z,F_Mode_2_Windows_Menu
    push    af              ;------------------------------------------->> Save XX, 0014
    call    F_Mode_2_Shadow_Text_Windows
    ld  a,h \   sub 5d  \   ld  h,a
    ld  a,d \   sub 5d  \   ld  d,a
    call    F_Mode_2_Shadow_Text_Windows
    pop     af              ;------------------------------------------->> Load XX, 0014
    dec a
    ld  (Janela_Escolhida),a
    jr  F_Mode_2_Windows_Menu
F_Mode_2_Windows_Cursor_Position_Down:   
;The select cursor moves to down
    ld  a,(Janelas_Minimizadas) \   ld  b,a \   ld  a,(Janela_Escolhida)
    cp  b   \   jr  z,F_Mode_2_Windows_Menu
    push    af              ;------------------------------------------->> Save XX, 0015
    ld  a,h \   add a,5d    \   ld  h,a
    ld  a,d \   add a,5d    \   ld  d,a
    call    F_Mode_2_Shadow_Text_Windows
    pop     af              ;------------------------------------------->> Load XX, 0015
    inc a
    ld  (Janela_Escolhida),a
    jr  F_Mode_2_Windows_Menu
F_Mode_2_Windows_Maximate_Select:
    ld  hl,Janela_M_1-2
    ld  a,(Janela_Escolhida)    \   ld  b,a
F_Mode_2_Windows_Maximate_Select_Execute:
    inc hl  \   inc hl
    djnz    F_Mode_2_Windows_Maximate_Select_Execute
    xor a
    ld  (saveSScreen+54),a
    push    hl              ;------------------------------------------->> Save XX, 0016
    ld  a,(Janelas_Minimizadas) \   dec a   \   ld  (Janelas_Minimizadas),a
    ld  a,(hl)  \   ld  (Janela_Actual+1),a \   xor a   \   ld  (hl),a  \   inc hl
    ld  a,(hl)  \   ld  (Janela_Actual),a   \   xor a   \   ld  (hl),a
    pop     hl              ;------------------------------------------->> Load XX, 0016
    call    F_Mode_2_Desfragmentation_Windows_Minimizates
    jp  F_Mode_5_Window_Activate
F_Mode_2_Desfragmentation_Windows_Minimizates:
    inc hl      \   inc hl  \   ld  a,(hl)
    cp  0       \   ret z
    ld  a,(hl)  \   ld  b,a \   inc hl
    ld  a,(hl)  \   dec hl  \   dec hl
    dec hl
    ld  (hl),b  \   inc hl  \   ld  (hl),a
    inc hl      \   inc hl
    jr  F_Mode_2_Desfragmentation_Windows_Minimizates
F_Mode_2_Shadow_Text_Windows:
    push    hl              ;------------------------------------------->> Save XX, 0017
    push    de              ;------------------------------------------->> Save XX, 0018
    set plotLoc,(IY+plotFlags)
    ld  hl,saveSScreen
    ld  de,OP1+2
    ld  bc,200d
    ldir
    pop     de              ;------------------------------------------->> Load XX, 0018
    pop     hl              ;------------------------------------------->> Load XX, 0017
    push    hl              ;------------------------------------------->> Save XX, 0019
    push    de              ;------------------------------------------->> Save XX, 0020
    b_call  _InvertRect
    ld  de,saveSScreen
    ld  hl,OP1+2
    ld  bc,200d
    ldir
    pop     de              ;------------------------------------------->> Load XX, 0020
    pop     hl              ;------------------------------------------->> Load XX, 0019
    ret
F_Mode_2_Alpha_Press:
    ld  a,1d    \   ld  (Alpha),a
    call    F_Mode_2_5_Alpha_Press_Execute
    jp  F_Mode_2_Activate
F_Mode_2_Enter_Press:
    call    F_Mode_2_5_Determinate_Cursor_Position
    ld  a,(Icone_Selecionado)
    cp  11d \   jp  z,F_Mode_4_Activate
    cp  25d \   jp  z,F_Mode_7_Activate
    ld  hl,F_Mode_5_Activate    \   push    hl
    ld  hl,Matriz_Amb_Icone_2   \   ld  de,2d   \   cp  12d \   ret z
    add hl,de   \   cp  13d \   ret z
    add hl,de   \   cp  14d \   ret z
    add hl,de   \   cp  15d \   ret z
    add hl,de   \   cp  21d \   ret z
    add hl,de   \   cp  22d \   ret z
    add hl,de   \   cp  23d \   ret z
    add hl,de   \   cp  24d \   ret z
    pop hl
    jp  F_Mode_2_Activate
;Bytes: 655    
;-----------------------------------------------------------------------------------------------------------------------
;Mode 3
;-----------------------------------------------------------------------------------------------------------------------
;Nota:Necessita de um atraso
F_Mode_3_Activate:
    b_call  _ClrScrnFull
    b_call  _GrBufClr
    ld  c,10d   \   ld  b,49d
    ld  hl,I_Iniciar_Opcoes
    ld  de,plotSScreen+85
F_Mode_3_Show_Iniciar:
    ld  a,(hl)  \   ld  (de),a
    inc hl      \   inc de
    dec c       \   ld  a,c
    cp  0       \   jr  nz,F_Mode_3_Show_Iniciar
    ld  c,10d
    inc de      \   inc de
    djnz    F_Mode_3_Show_Iniciar
    ld  hl,(Apontador_AppVar_Utiliz)    \   inc hl
    ld  a,(hl)
    res plotLoc,(IY+plotFlags)
    call    Desenhar_Barra_De_Ferramentas
    b_call  _GrBufCpy
    ld  a,0ffh  \   ld  (Iniciar_Rectangulo),a
    ld  a,1d    \   ld  (Interrupcao_Rato),a
    ld  (Amb_Iniciar_Pastas_Pgrm),a
    xor a       \   ld  (XPos_Rato),a
    ld  a,63d   \   ld  (YPos_Rato),a
F_Mode_3_General_Routine:
    call    Rato_Windows
    cp  1   \   jp  z,F_Mode_3_2nd_Press
    ld  a,(YPos_Rato)
    cp  9d  \   jr  c,F_Mode_3_Test_Tools_Bar
    cp  56d \   jr  nc,F_Mode_3_Position_Cursor_Indeterminate
    ld  a,(XPos_Rato)
    cp  14d \   jr  c,F_Mode_3_Position_Cursor_Indeterminate
    cp  82d \   jr  nc,F_Mode_3_Position_Cursor_Indeterminate
    ld  hl,F_Mode_3_Shadow_Option   \   push    hl
    ld  a,(YPos_Rato)
    ld  b,4d    \   cp  13d \   ret c
    inc b       \   cp  19d \   ret c
    inc b       \   cp  25d \   ret c
    inc b       \   cp  31d \   ret c
    inc b       \   cp  37d \   ret c
    inc b       \   cp  43d \   ret c
    inc b       \   cp  49d \   ret c
    inc b       \   cp  55d \   ret c
    pop hl
    jr  F_Mode_3_General_Routine
F_Mode_3_Test_Tools_Bar:
    ld  a,(YPos_Rato)
    cp  6d  \   jr  nc,F_Mode_3_Position_Cursor_Indeterminate
    xor a   \   ld  hl,Iniciar_Rectangulo   \   ld  (hl),a
    ld  a,(XPos_Rato)
    cp  70d \   jr  nc,F_Mode_3_General_Routine \   inc (hl)    \   inc (hl)
    cp  30d \   jr  nc,F_Mode_3_General_Routine \   dec (hl)
    jr  F_Mode_3_General_Routine
F_Mode_3_Position_Cursor_Indeterminate:
    ld  a,(Iniciar_Rectangulo)
    call    F_Mode_3_Shadow_Rect
    ld  a,0ffh
    ld  (Iniciar_Rectangulo),a
    jr  F_Mode_3_General_Routine
F_Mode_3_Shadow_Option:
    ld  a,(Iniciar_Rectangulo)
    cp  b   \   jr  z,F_Mode_3_General_Routine
    push    bc
    call    F_Mode_3_Shadow_Rect
    pop     bc
    ld  a,b
    ld  (Iniciar_Rectangulo),a
    call    F_Mode_3_Shadow_Rect
    jp  F_Mode_3_General_Routine
F_Mode_3_Shadow_Rect:
    ld  hl,F_Mode_3_Draw_Shadow \   push    hl
    ld  l,12d
    ld  h,8d    \   cp  11  \   ret z
    ld  h,14d   \   cp  10  \   ret z
    ld  h,20d   \   cp  9   \   ret z
    ld  h,26d   \   cp  8   \   ret z
    ld  h,32d   \   cp  7   \   ret z
    ld  h,38d   \   cp  6   \   ret z
    ld  h,44d   \   cp  5   \   ret z
    ld  h,50d   \   cp  4   \   ret z
    pop hl
    ret
F_Mode_3_Draw_Shadow:
    ld  d,h     \   ld  e,l
    inc d       \   inc d
    inc d       \   inc d
    ld  a,71d   \   add a,e
    ld  e,a
    res plotLoc,(IY+plotFlags)
    push    de
    push    hl
    ld  hl,saveSScreen
    ld  de,OP1+2
    ld  bc,200d
    ldir
    pop     hl
    pop     de
    b_call  _InvertRect
    ld  de,saveSScreen
    ld  hl,OP1+2
    ld  bc,200d
    ldir
    ret    
F_Mode_3_2nd_Press:    
    ld  a,(Iniciar_Rectangulo)
    cp  0       \   jp  z,Exit_Aplication
    cp  0ffh    \   jp  z,F_Mode_2_Activate
    cp  1       \   jp  z,F_Mode_2_Activate
    cp  4       \   jp  z,F_ModeA_1_Activate
    cp  5       \   jp  z,F_ModeA_2_Activate
    cp  6       \   jp  z,F_ModeA_3_Activate
    cp  7       \   jp  z,F_ModeA_4_Activate
    cp  8       \   jr  z,F_Mode_4_Activate
    cp  9       \   jp  z,F_ModeA_8_Activate
    cp  11      \   jp  z,F_ModeA_9_Activate
    cp  10      \   jp  z,F_ModeA_6_Activate
    jp  F_Mode_3_General_Routine
;Bytes:321
;-----------------------------------------------------------------------------------------------------------------------
;Mode 4
;----------------------------------------------------------------------------------------------------------------------- 
F_Mode_4_Activate:
    ld  b,1 \   ld  c,6 \   ld  d,0
    ld  hl,Menu_Principal_T
    ld  a,h \   ld  (Menu_Maker_Buffer+1),a
    ld  a,l \   ld  (Menu_Maker_Buffer+2),a
    ld  hl,Menu_Texto_1
    ld  a,h \   ld  (Menu_Maker_Buffer+3),a
    ld  a,l \   ld  (Menu_Maker_Buffer+4),a
    ld  hl,Menu_Texto_2
    ld  a,h \   ld  (Menu_Maker_Buffer+5),a
    ld  a,l \   ld  (Menu_Maker_Buffer+6),a
    ld  hl,Menu_Texto_3
    ld  a,h \   ld  (Menu_Maker_Buffer+7),a
    ld  a,l \   ld  (Menu_Maker_Buffer+8),a
    ld  hl,Menu_Texto_4
    ld  a,h \   ld  (Menu_Maker_Buffer+9),a
    ld  a,l \   ld  (Menu_Maker_Buffer+10),a
    ld  hl,Menu_Texto_5
    ld  a,h \   ld  (Menu_Maker_Buffer+11),a
    ld  a,l \   ld  (Menu_Maker_Buffer+12),a
    ld  hl,Menu_Texto_6
    ld  a,h \   ld  (Menu_Maker_Buffer+13),a
    ld  a,l \   ld  (Menu_Maker_Buffer+14),a
    call    Carregar_Menu_Maker
    push    af
    pop af
    cp  1   \   jp  z,F_ModeA_3_Activate
    cp  2   \   jp  z,F_ModeA_4_Activate
    cp  3   \   jp  z,F_ModeA_5_Activate
    cp  4   \   jp  z,F_ModeA_6_Activate
    cp  5   \   jp  z,F_ModeA_7_Activate
    cp  6   \   jp  z,F_Mode_2_Activate
    cp  0   \   jp  z,F_Mode_2_Activate
    jr  F_Mode_4_Activate
;Bytes:137
;-----------------------------------------------------------------------------------------------------------------------
;Mode 5
;-----------------------------------------------------------------------------------------------------------------------
F_Mode_5_Activate:
    ld  a,(hl)  \   ld  b,a \   inc hl
    ld  a,(hl)  \   ld  h,b \   ld  l,a
    ld  (Janela_Actual),hl
F_Mode_5_Window_Activate:
    ld  hl,Matriz_Amb_Icone_1
    ld  b,20d
    xor a
F_Mode_5_Erase_Buffer_Icons:
    ld  (hl),a
    inc hl
    djnz    F_Mode_5_Erase_Buffer_Icons
    b_call  _GrBufClr
    b_call  _ClrScrnFull
    call    Desenhar_Janela
    ld  hl,(Janela_Actual)
    inc hl  \   inc hl
    inc hl  \   ld  a,(hl)
    cp  0   \   jp  z,F_Mode_6_Activate
    inc hl
    ld  a,(hl)  \   ld  (Buffer_Texto),a    \   inc hl
    ld  a,(hl)  \   ld  (Buffer_Texto+1),a  \   inc hl
    ld  a,(hl)  \   ld  (Buffer_Texto+2),a  \   inc hl
    ld  a,(hl)  \   ld  (Buffer_Texto+3),a
    ld  hl,(Janela_Actual)
    call    Procurar_Icones
    ld  b,10d
    ld  hl,Matriz_Amb_Icone_1
    call    F_Mode_2_5_Refresh_Matriz
    call    F_Mode_5_Window_Insert_Name
    xor a       \   ld  (Interrupcao_Rato),a
    ld  (Icone_Selecionado),a
    inc a       \   ld  (Amb_Iniciar_Pastas_Pgrm),a
    ld  a,46d   \   ld  (XPos_Rato),a
    ld  a,31d   \   ld  (YPos_Rato),a
F_Mode_5_General_Routine:
    call    Rato_Windows
    cp  1   \   jr  z,F_Mode_5_2nd_Press
    cp  2   \   jp  z,F_Mode_5_Alpha_Press
    cp  3   \   jp  z,F_Mode_5_Enter_Press
    jp  F_Mode_5_General_Routine    
F_Mode_5_Window_Insert_Name: 
    ld  a,(Posicao_Iniciar)
    cp  1   \   jr  z,F_Mode_5_Insert_Text_1
    cp  2   \   jr  z,F_Mode_5_Insert_Text_2
F_Mode_5_Insert_Text_3_4:
    ld  a,6     \   ld  (penCol_FrtzOS),a
    ld  a,1     \   ld  (penRow_FrtzOS),a
    ld  hl,Buffer_Texto
    xor a
    ld  (Buffer_Texto+4),a
    ld  bc,0*256+1
    call    PutSS
    ret   
F_Mode_5_Insert_Text_2:
    ld  a,46    \   ld  (penCol_FrtzOS),a
    ld  a,60    \   ld  (penRow_FrtzOS),a
    ld  hl,Buffer_Texto
    xor a
    ld  (Buffer_Texto+4),a
    ld  bc,1*256+1
    call    PutSS
    ret
F_Mode_5_Insert_Text_1:
    ld  a,46    \   ld  (penCol_FrtzOS),a
    ld  a,1     \   ld  (penRow_FrtzOS),a
    ld  hl,Buffer_Texto
    xor a
    ld  (Buffer_Texto+4),a
    ld  bc,1*256+1
    call    PutSS
    ret
F_Mode_5_2nd_Press:  
    call    F_Mode_2_5_Determinate_Cursor_Position
    ld  a,b
    cp  0ffh    \   jr  z,F_Mode_5_Verify_Shadow_Icon
    cp  0       \   jp  z,Exit_Aplication
    cp  1       \   jp  z,F_Mode_3_Activate
    cp  3       \   jp  z,F_Mode_2_Activate
    cp  4       \   jr  z,F_Mode_5_Minimizate_Window
    cp  5       \   jr  z,F_Mode_5_Menu_Paste
    cp  11d     \   call    nc,F_Mode_2_5_Select_Icon
    jp  F_Mode_5_General_Routine
F_Mode_5_Verify_Shadow_Icon:
;Verify if a icon is select, if is, deselect them
    ld  a,(Icone_Selecionado)
    cp  0   \   jp  z,F_Mode_5_General_Routine
    call    F_Mode_2_5_Select_Deselect_Icon
    xor a
    ld  (Icone_Selecionado),a
    jp  F_Mode_5_General_Routine    
F_Mode_5_Minimizate_Window:
    ld  a,(Janelas_Minimizadas)
    cp  10d \   jp  z,F_Mode_5_General_Routine
    ;...Dar o conhecimento do erro, por acabar
    inc a   \   ld  (Janelas_Minimizadas),a
    ld  b,10d   \   ld  hl,Janela_M_10
    call    F_Mode_5_Find_Andress_Window
    ld  de,(Janela_Actual)
    ld  a,d \   ld  (hl),a  \   inc hl
    ld  a,e \   ld  (hl),a
    jp  F_Mode_2_Activate
F_Mode_5_Find_Andress_Window:
    cp  b   \   ret z
    dec hl  \   dec hl
    djnz    F_Mode_5_Find_Andress_Window
    ret
F_Mode_5_Menu_Paste:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  (Buffer_Texto+4),a
    ld  hl,Buffer_Texto
    set textInverse,(IY+textFlags)
    call    PutSApp
    res textInverse,(IY+textFlags)
    xor a   \   ld  (curCol),a
    inc a   \   ld  (curRow),a
    ld  hl,T_Menu_Pasta
    call    PutSApp
F_Mode_5_Menu_Paste_Execute:
    b_call  _GetKey
    cp  k3  \   jp  z,F_Mode_5_Window_Activate
    cp  k2  \   jr  z,F_Mode_5_Back_Window
    cp  k1  \   jr  z,F_Mode_5_Create_Paste
    jr  F_Mode_5_Menu_Paste_Execute
F_Mode_5_Create_Paste:
    call    F_Mode_2_5_Create_Paste
    jp  F_Mode_5_Window_Activate
F_Mode_5_Back_Window:
    ld  hl,(Janela_Actual)
    ld  a,(hl)  \   cp  99h \   jp  z,F_Mode_2_Activate \   ld  b,a
    inc hl      \   ld  a,(hl)
    ld  h,b     \   ld  l,a
    ld  (Janela_Actual),hl
    jp  F_Mode_5_Window_Activate
F_Mode_5_Alpha_Press:
    xor a
    ld  (Alpha),a
    call    F_Mode_2_5_Alpha_Press_Execute
    jp  F_Mode_5_Window_Activate
F_Mode_5_Enter_Press:
    ld  a,(Icone_Selecionado)
    ld  hl,F_Mode_5_Activate \   push    hl
    ld  hl,Matriz_Amb_Icone_1       \   ld  de,2d   \   cp  11d \   ret z
    add hl,de   \   cp  12d \   ret z
    add hl,de   \   cp  13d \   ret z
    add hl,de   \   cp  14d \   ret z
    add hl,de   \   cp  15d \   ret z
    add hl,de   \   cp  21d \   ret z
    add hl,de   \   cp  22d \   ret z
    add hl,de   \   cp  23d \   ret z
    add hl,de   \   cp  24d \   ret z
    add hl,de   \   cp  25d \   ret z
    pop hl
    jp  F_Mode_5_Window_Activate
;Bytes:423    
;-----------------------------------------------------------------------------------------------------------------------
;Mode 6
;-----------------------------------------------------------------------------------------------------------------------
F_Mode_6_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Executar
    call    PutSApp
    b_call  _GetKey
    cp  kLog    \   jp  z,F_Mode_2_Activate
    cp  kLn     \   jr  nz,F_Mode_6_Activate
F_Mode_6_Execute:
    ld  hl,(Janela_Actual)
    ld  de,9d
    add hl,de
    ld  de,Buffer_Executar+1
    ld  bc,8d
    ldir
    xor a
    ld  (hl),a
    ld  a,ProgObj
    ld  (Buffer_Executar),a
    ld  hl,Buffer_Executar
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    jr  nc,F_Mode_6_Arc_Unarc
    ld  a,ProtProgObj
    ld  (Buffer_Executar),a
    ld  hl,Buffer_Executar
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    jp  c,F_Mode_6_Err_Not_Found
F_Mode_6_Arc_Unarc:
    ld  hl,Buffer_Executar
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    ld  a,b
    or  a   \   jr  z,F_Mode_6_Basic_Assembler_Select
    ld  hl,Buffer_Executar
    b_call  _Mov9ToOP1
    b_call  _Arc_Unarc
F_Mode_6_Basic_Assembler_Select:
    call    F_Mode_6_Save_saveSScreen
    ld  hl,F_Mode_6_Assembler_Select
    call    Erro_Assembler
    ld  hl,F_Mode_6_End_Of_Program
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    jr  c,F_Mode_6_Create_Basic_Pgrm_Master
    b_call  _DelVarArc
F_Mode_6_Create_Basic_Pgrm_Master:
    ld  b,0 \   ld  hl,Buffer_Executar+1
F_Mode_6_Create_Basic_Pgrm_Master_Execute:
    ld  a,(hl)
    inc b   \   inc hl
    cp  0   \   jr  nz,F_Mode_6_Create_Basic_Pgrm_Master_Execute
    dec b
    ld  hl,F_Mode_6_End_Of_Program-F_Mode_6_Data_Of_Program-2
    ld  e,b
    ld  d,0
    add hl,de
    push    bc
    b_call  _CreateProtProg
    inc de
    inc de
    ld  hl,F_Mode_6_Data_Of_Program+2
    ld  bc,F_Mode_6_End_Of_Program-F_Mode_6_Data_Of_Program-2
    ldir
    ld  hl,Buffer_Executar+1
    pop bc
    ld  c,b
    ld  b,0
    ldir
    call    Arquivar_AppVars
    ld  hl,F_Mode_6_End_Of_Program
    b_call  _Mov9ToOP1
    b_call  _ParseInp
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Feito
    call    PutSApp
    b_call  _GetKey
    jr  F_Mode_6_Execute_Over
F_Mode_6_Assembler_Select:
    call    Erro_D
    ld  hl,F_Mode_6_Err_To_Execute
    call    Erro_Assembler
    ld  hl,F_Mode_6_End_Of_Program
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    b_call  _DelVarArc
    ld  b,0 \   ld  hl,Buffer_Executar+1
F_Mode_6_Create_Asm_Pgrm_Master_Execute:
    ld  a,(hl)
    inc b   \   inc hl
    cp  0   \   jr  nz,F_Mode_6_Create_Asm_Pgrm_Master_Execute
    dec b
    ld  hl,F_Mode_6_End_Of_Program-F_Mode_6_Data_Of_Program
    ld  e,b
    ld  d,0
    add hl,de
    push    bc
    b_call  _CreateProtProg
    inc de
    inc de
    ld  hl,F_Mode_6_Data_Of_Program
    ld  bc,F_Mode_6_End_Of_Program-F_Mode_6_Data_Of_Program
    ldir
    ld  hl,Buffer_Executar+1
    pop bc
    ld  c,b
    ld  b,0
    ldir
    ld  hl,F_Mode_6_End_Of_Program
    b_call  _Mov9ToOP1
    b_call  _ParseInp
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Feito
    call    PutSApp
    b_call  _GetKey
F_Mode_6_Execute_Over:
    call    Desarquivar_AppVars 
    call    F_Mode_6_Load_saveSScreen  
    call    Erro_D
    ld  hl,Buffer_Executar
    b_call  _Mov9ToOP1
    b_call  _Arc_Unarc
    ld  hl,F_Mode_6_End_Of_Program
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    b_call  _DelVar
    ld  a,(Utilizador_Activo)      
    ld  hl,T_AppVar_Nm1
    cp  1   \   jr  z,F_Mode_6_Execute_Over_Restart_System
    ld  hl,T_AppVar_Nm2
F_Mode_6_Execute_Over_Restart_System:
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    inc de
    inc de
    inc de
    ld  (Apontador_AppVar_Utiliz),de
    jp  F_Mode_2_Activate
F_Mode_6_Err_Not_Found:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_1
    call    PutSApp
    b_call  _GetKey
    jp  F_Mode_2_Activate
F_Mode_6_Err_To_Execute:
    res onInterrupt,(IY+onFlags)
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_2
    call    PutSApp
    b_call  _GetKey
    jr  F_Mode_6_Execute_Over
F_Mode_6_Save_saveSScreen:
    ld  hl,F_Mode_6_AppVar_Saver_Name
    b_call  _Mov9ToOP1
    ld  hl,250d
    b_call  _CreateAppVar
    inc de
    inc de
    ld  hl,saveSScreen
    ld  bc,200d
    ldir
    ret
F_Mode_6_Load_saveSScreen:
    ld  hl,F_Mode_6_AppVar_Saver_Name
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    push    de
    push    hl
    push    bc
    inc de
    inc de
    ex  de,hl
    ld  de,saveSScreen
    ld  bc,200d
    ldir
    pop bc
    pop hl
    pop de
    b_call  _DelVarArc
    ret   
F_Mode_6_AppVar_Saver_Name:
    .db AppVarObj,"FrtzSave",0
    
    

F_Mode_6_Data_Of_Program:
    .db t2ByteTok,tasm,tProg
F_Mode_6_End_Of_Program:    
    .db ProtProgObj,"Z",0
;Bytes: 283    
;-----------------------------------------------------------------------------------------------------------------------
;Mode 7
;-----------------------------------------------------------------------------------------------------------------------
F_Mode_7_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Certeza
    call    PutSApp
    b_call  _GetKey
    cp  kLog    \   jp  z,F_Mode_2_Activate
    cp  kLn     \   jr  nz,F_Mode_7_Activate
    ld  b,100d
    ld  de,97d
    ld  hl,(Apontador_AppVar_Utiliz)
    add hl,de
    ld  de,20d  \   xor a
F_Mode_7_Erase_All_Pastes:
    ld  (hl),a  \   add hl,de
    djnz    F_Mode_7_Erase_All_Pastes
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Feito
    call    PutSApp
    b_call  _GetKey
    jp  z,F_Mode_2_Activate
    
    

;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 1
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_1_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Encerrar
    call    PutSApp
    b_call  _GetKey
    cp  kLn     \   jr  z,F_ModeA_1_TurnOff_Calc
    cp  kLog    \   jp  z,F_Mode_2_Activate
    jr  F_ModeA_1_Activate
F_ModeA_1_TurnOff_Calc:    
    ld a,1
    out (3),a
    halt
    ld a,11
    out (3),a        
    res onInterrupt,(IY+onFlags)
    b_call  _GetCSC
    jp  F_Mode_1_LogOn
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 2
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_2_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Terminar_Sessao
    call    PutSApp
    b_call  _GetKey
    cp  kLog    \   jp  z,F_Mode_2_Activate
    cp  kLn     \   jp  z,F_Mode_1_LogOn
    jr  F_ModeA_2_Activate
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 3
;-----------------------------------------------------------------------------------------------------------------------
; Not avaible   
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 4
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_4_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Painel_De_Controlo
    call    PutSApp
    b_call  _GetKey
    cp  k2  \   jp  z,F_Mode_2_Activate
    cp  k1  \   jr  nz,F_ModeA_4_Activate
    ld  b,54d
    ld  hl,Buffer_Texto
    xor a
F_ModeA_4_Instale:
    ld  (hl),a
    inc hl
    djnz    F_ModeA_4_Instale
    ld  hl,Buffer_Texto
    ld  (Buffer_Test),hl
    ld  hl,(progPtr)
    call    F_ModeA_4_Find_Program
    call    F_ModeA_4_Skip_Find
    call    F_ModeA_4_Find_Program
    call    F_ModeA_4_Skip_Find
    push    hl
    call    F_ModeA_4_Find_Program
    ld  a,b \   cp  0   \   jp  z,F_ModeA_4_No_Programs
    res appTextSave,(IY+textFlags)
    b_call  _ClrScrnFull
    pop hl
F_ModeA_4_MainLoop:
    ld  a,2d    \   ld  (curCol),a
    ld  a,1d    \   ld  (curRow),a
    ld  c,6d
F_ModeA_4_FindLoop:
    ld  de,(pTemp)
    or  a
    sbc hl,de
    jp  z,F_ModeA_4_Done
    jp  c,F_ModeA_4_Done
    add hl,de
    ld  a,(hl)
    and 1fh
    cp  ProgObj     \   jr  z,F_ModeA_4_Defined_Text
    cp  ProtProgObj \   jr  z,F_ModeA_4_Defined_Text
    jp  F_ModeA_4_Skip
F_ModeA_4_Defined_Text    
    ld  de,-6
    add hl,de
    ld  b,(hl)
    ld  de,(Buffer_Test)
F_ModeA_4_DispNameLoop:
    dec hl
    ld  a,(hl)
    ld  (de),a
    b_call  _PutC
    inc de
    djnz    F_ModeA_4_DispNameLoop
    inc de
    ld  (Buffer_Test),de
    dec hl
    push    bc
    b_call  _newline
    pop     bc
    ld  a,2d    \   ld  (curCol),a
    dec c
    jr  nz,F_ModeA_4_FindLoop
F_ModeA_4_Page_Change_Menu
    push    hl  \   push    bc
    call    F_ModeA_4_Insert_Options
    b_call  _GetKey
    pop     bc  \   pop     hl
    cp  kEnter  \   jp  z,F_ModeA_4_Page_Change_Execute
    cp  k1      \   jp  z,F_ModeA_4_Select_1
    cp  k2      \   jp  z,F_ModeA_4_Select_2
    cp  k3      \   jp  z,F_ModeA_4_Select_3
    cp  k4      \   jp  z,F_ModeA_4_Select_4
    cp  k5      \   jp  z,F_ModeA_4_Select_5
    cp  k6      \   jp  z,F_ModeA_4_Select_6
    cp  kClear  \   jp  z,F_Mode_2_Activate
    jp  F_ModeA_4_Page_Change_Menu
F_ModeA_4_Page_Change_Execute:    
    push    hl  \   push    bc
    b_call  _ClrLCDFull
    pop     bc  \   pop     hl
    jp  F_ModeA_4_MainLoop
F_ModeA_4_Skip:
    or  a
    ld  de,6
    sbc hl,de
    ld  e,(hl)
    inc e
    sbc hl,de
    jp  F_ModeA_4_FindLoop
F_ModeA_4_Done:
    push    hl  \   push    bc
    call    F_ModeA_4_Insert_Options
    b_call  _GetKey
    pop     bc  \   pop     hl
    cp  kEnter  \   jp  z,F_ModeA_4_Instale
    cp  k1      \   jp  z,F_ModeA_4_Select_1
    cp  k2      \   jp  z,F_ModeA_4_Select_2
    cp  k3      \   jp  z,F_ModeA_4_Select_3
    cp  k4      \   jp  z,F_ModeA_4_Select_4
    cp  k5      \   jp  z,F_ModeA_4_Select_5
    cp  k6      \   jp  z,F_ModeA_4_Select_6
    cp  kClear  \   jp  z,F_Mode_2_Activate
    jp  F_ModeA_4_Done
F_ModeA_4_Find_Program:
    or  a
    ld  de,(pTemp)
    sbc hl,de
    ld  b,0d
    ret z
    ret c
    add hl,de
    ld  a,(hl)
    and 1fh
    ld  b,1d
    cp  ProgObj     \   ret z
    cp  ProtProgObj \   ret z
F_ModeA_4_Skip_Find:    
    or  a
    ld  de,6
    sbc hl,de
    ld  e,(hl)
    inc e
    sbc hl,de
    jr  F_ModeA_4_Find_Program
F_ModeA_4_Insert_Options:
    ;B=0 -> Sem proxima pagina B=1 -> Com proxima pagina
    ;C=Nr de Programas
    push    bc
    xor a
    ld  (curCol),a
    ld  (curRow),a
    set textInverse,(IY+textFlags)
    ld  hl,T_Encontrar_P
    call    PutSApp
    push    hl
    b_call  _newline
    pop     hl
    res textInverse,(IY+textFlags)
    inc hl
    pop bc
    ld  a,6d    \   sub c   \   ld  c,a \   cp  0   \   jp  z,F_ModeA_4_Instale
    ld  a,b     \   ld  b,c \   ld  c,a
F_ModeA_4_Insert_Options_Execute:    
    push    bc
    call  PutSApp
    push    hl
    b_call  _newline
    pop     hl
    pop     bc
    inc hl
    djnz    F_ModeA_4_Insert_Options_Execute
    ld  a,7d    \   ld  (curRow),a
    ld  hl,T_Next_Page
    call    PutSApp
    ret
F_ModeA_4_No_Programs:
    pop hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_4
    call    PutSApp
    b_call  _GetKey
    jp  F_Mode_2_Activate 
F_ModeA_4_Select_1:
    ld  hl,Buffer_Texto
    jr  F_ModeA_4_Insert_Icon_Instaled
F_ModeA_4_Select_2:
    ld  a,c \   cp  5   \   jp  nc,F_ModeA_4_Done
    ld  b,1 \   ld  hl,Buffer_Texto
    call    F_ModeA_4_Search_Text
    jr  F_ModeA_4_Insert_Icon_Instaled
F_ModeA_4_Select_3:
    ld  a,c \   cp  4   \   jp  nc,F_ModeA_4_Done
    ld  b,2 \   ld  hl,Buffer_Texto
    call    F_ModeA_4_Search_Text
    jr  F_ModeA_4_Insert_Icon_Instaled
F_ModeA_4_Select_4:
    ld  a,c \   cp  3   \   jp  nc,F_ModeA_4_Done
    ld  b,3 \   ld  hl,Buffer_Texto
    jr  F_ModeA_4_Insert_Icon_Instaled
F_ModeA_4_Select_5:
    ld  a,c \   cp  2   \   jp  nc,F_ModeA_4_Done
    ld  b,4 \   ld  hl,Buffer_Texto
    call    F_ModeA_4_Search_Text
    jr  F_ModeA_4_Insert_Icon_Instaled
F_ModeA_4_Select_6:
    ld  a,c \   cp  1   \   jp  nc,F_ModeA_4_Done
    ld  b,5 \   ld  hl,Buffer_Texto
    call    F_ModeA_4_Search_Text
    jr  F_ModeA_4_Insert_Icon_Instaled   
F_ModeA_4_Search_Text:
    ld  a,(hl)
    inc hl
    cp  0   \   jr  nz,F_ModeA_4_Search_Text    
    djnz    F_ModeA_4_Search_Text
    ret
F_ModeA_4_Insert_Icon_Instaled:
    push    hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_CP_Nome
    call    PutSApp
    ld  hl,(Apontador_AppVar_Utiliz)
    ld  de,97d
    add hl,de
    call    F_ModeA_4_Find_Space
    ld  de,Matriz_Amb_Icone_1   \   ld  c,1 \   ld  b,10
    call    F_ModeA_4_Find_Position
    ld  de,(Janela_Actual)
    ld  (hl),d  \   inc hl
    ld  (hl),e  \   inc hl
    ld  a,c     \   ld  (hl),a  \   inc hl
    xor a       \   ld  (hl),a  \   inc hl
    ld  b,4
    call    Pedir_Texto_Escrever_Pequeno
    xor a
    ld  (hl),a  \   inc hl
    pop de
    ld  b,8d
    xor a
    ld  (Buffer_Texto-1),a
F_ModeA_4_Insert_Name_Icon:
    ld  a,(de)  \   cp  0   \   jr  z,F_ModeA_4_Name_Inserted_Icon
    ld  (hl),a
    inc de
    inc hl
    dec b
    jr  F_ModeA_4_Insert_Name_Icon
F_ModeA_4_Name_Inserted_Icon:
    ld  a,b
    add a,3d
    ld  b,a
F_ModeA_4_Instaled_End:
    xor a
    ld  (hl),a
    inc hl
    djnz    F_ModeA_4_Instaled_End
F_ModeA_4_Exit:    
    jp  F_Mode_2_Activate    
F_ModeA_DE_Correct:
    ld  a,(de)  \   cp  0   \   ret z
    inc de
    jp  F_ModeA_DE_Correct
F_ModeA_4_Find_Position    
    ld  a,(de)  \   cp  0   \   ret z
    inc de      \   inc de  \   inc c
    djnz  F_ModeA_4_Find_Position
    pop hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_6
    call    PutSApp
    b_call  _GetKey
    jr  F_ModeA_4_Exit 
F_ModeA_4_Find_Space:
    ld  a,(hl)  \   cp  0   \   ret z
    ld  de,20d
    add hl,de
    djnz    F_ModeA_4_Find_Space
    pop hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_5
    call    PutSApp
    b_call  _GetKey
    jr  F_ModeA_4_Exit        
;Bytes:558  
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 5
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_5_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Ferramentas_Do_Sistema
    call    PutSApp
    b_call  _GetKey
    cp  k1  \   jr  z,F_ModeA_5_Instale_ScreenSaver
    cp  k2  \   jr  z,F_ModeA_5_Iniciar_Position
    cp  k3  \   jp  z,F_Mode_2_Activate
    jr  F_ModeA_5_Activate
F_ModeA_5_Iniciar_Position
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Escolha_Iniciar
    call    PutSApp
    b_call  _GetKey
    ld  b,1 \   cp  k1  \   jr  z,F_ModeA_Iniciar_Position_Select
    inc b   \   cp  k2  \   jr  z,F_ModeA_Iniciar_Position_Select
    inc b   \   cp  k3  \   jr  z,F_ModeA_Iniciar_Position_Select
    inc b   \   cp  k4  \   jr  z,F_ModeA_Iniciar_Position_Select
    jr  F_ModeA_5_Iniciar_Position
F_ModeA_Iniciar_Position_Select:
    ld  a,b
    ld  (Posicao_Iniciar),a
    ld  hl,(Apontador_AppVar_Utiliz)
    inc hl
    ld  (hl),a
    jp  F_Mode_2_Activate
F_ModeA_5_Instale_ScreenSaver:
    jp  F_Beta
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 6
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_6_Activate:
    b_call  _ClrScrnFull
    ld  hl,T_AppVar_Geral
    b_call  _Mov9ToOP1
    b_call  _ChkFindSym
    ex  de,hl
    inc hl  \   inc hl
    inc hl  \   inc hl
    inc hl
    ld  a,(Utilizador_Activo)
    cp  1   \   jr  z,F_ModeA_6_Utiliz_1
    ld  de,8
    add hl,de
    call    CAG_Registos_Utilizador_2
    jp  F_Mode_2_Activate
F_ModeA_6_Utiliz_1
    call    CAG_Registos_Utilizador_1
    jp  F_Mode_2_Activate
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 7
;-----------------------------------------------------------------------------------------------------------------------        
F_ModeA_7_Activate:
    b_call  _GrBufClr
    ld  hl,FreitazOS_Imagem
    ld  bc,768d
    ld  de,plotSScreen
    ldir
    b_call  _GrBufCpy
    b_call  _GetKey
    jp  F_Mode_2_Activate
;Beta Test
F_Beta:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Beta
    call    PutSApp
    b_call  _GetKey
    jp  F_ModeA_7_Activate
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 8
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_8_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Nome_Do_Ficheiro
    call    PutSApp
    ld  (Buffer_Texto+5),a
    ld  hl,Buffer_Texto
    ld  b,4d
    call    Pedir_Texto_Escrever_Pequeno
    ld  hl,(Apontador_AppVar_Utiliz)
    ld  de,101d
    add hl,de
    ld  de,Buffer_Texto
    ld  b,100d
F_ModeA_8_Find_Execute:
    ld  a,(de)
    cp  (hl)    \   jr  z,F_ModeA_8_Find_Process
    push    de
    ld  de,20d
    add hl,de
    pop de
    djnz    F_ModeA_8_Find_Execute
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_1
    call    PutSApp
    b_call  _GetKey
    jp  F_Mode_2_Activate
F_ModeA_8_Find_Process:
    push    hl  \   push    bc  \   push    de    
    inc hl  \   inc de  \   ld  a,(de)  \   cp  (hl)    \   jp  nz,F_ModeA_8_Err_Find_Process
    inc hl  \   inc de  \   ld  a,(de)  \   cp  (hl)    \   jp  nz,F_ModeA_8_Err_Find_Process
    inc hl  \   inc de  \   ld  a,(de)  \   cp  (hl)    \   jp  nz,F_ModeA_8_Err_Find_Process
F_ModeA_8_Find_Menu:
    pop de  \   pop bc
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Procurar_Menu
    call    PutSApp
    xor a   \   ld  (curRow),a
    ld  a,5 \   ld  (curCol),a
    ld  hl,Buffer_Texto
    call    PutSApp
    pop hl  \   push    hl
    dec hl
    call    F_ModeA_8_Program_Paste
    ld  a,1 \   ld  (curRow),a
    ld  a,5 \   ld  (curCol),a
    call    PutSApp
    pop hl  \   push    hl
    dec hl  \   dec hl
    dec hl  \   dec hl
    ld  a,(hl)  \   ld  b,a \   inc hl  \   cp  99h \   jr  z,F_ModeA_8_Inside_Amb
    ld  a,(hl)  \   ld  h,b \   ld  l,a
    inc hl  \   inc hl
    inc hl  \   inc hl
    ld  a,2 \   ld  (curRow),a
    ld  a,10\   ld  (curCol),a
    call    PutSApp     
    pop hl
F_ModeA_8_Find_Menu_Execute:
    push    hl
    b_call  _GetKey
    pop hl
    cp  kEnter  \   jr  z,F_ModeA_8_Continue_Find
    cp  kMode   \   jr  z,F_ModeA_8_Execute_Explorer
    cp  kClear  \   jp  z,F_Mode_2_Activate
    jr  F_ModeA_8_Find_Menu_Execute
F_ModeA_8_Err_Find_Process:
    pop de  \   pop bc  \   pop hl
    push    de
    ld  de,20d
    add hl,de
    pop de
    jp  F_ModeA_8_Find_Execute
F_ModeA_8_Continue_Find:
    ld  de,20d
    add hl,de
    ld  de,Buffer_Texto
    jp  F_ModeA_8_Find_Execute
F_ModeA_8_Execute_Explorer:
    dec hl  \   dec hl
    dec hl  \   dec hl
    ld  (Janela_Actual),hl
    jp  F_Mode_5_Window_Activate
F_ModeA_8_Inside_Amb:
    ld  hl,T_Inside_Amb
    ld  a,2 \   ld  (curRow),a
    ld  a,10\   ld  (curCol),a
    call    PutSApp
    pop hl
    jr  z,F_ModeA_8_Find_Menu_Execute
F_ModeA_8_Program_Paste:
    ld  a,(hl)
    ld  hl,T_Program    \   cp  0   \   ret z
    ld  hl,T_Paste
    ret    
T_Inside_Amb:    
    .db "----",0
T_Program:
    .db "Program",0
T_Paste:
    .db "Paste",0
;Bytes:261   
;-----------------------------------------------------------------------------------------------------------------------
;Mode A. 9
;-----------------------------------------------------------------------------------------------------------------------
F_ModeA_9_Activate:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Ajuda_E_Suporte
    call    PutSApp
    b_call  _GetKey
    cp  k1  \   jr  z,F_ModeA_9_Help_1
    cp  k2  \   jr  z,F_ModeA_9_Help_2
    cp  k3  \   jr  z,F_ModeA_9_Help_3
    cp  k4  \   jr  z,F_ModeA_9_Help_4
    cp  k5  \   jp  nz,F_ModeA_9_Activate
    jp  F_Mode_2_Activate
F_ModeA_9_Help_1:    
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_This_Shell_Is
    call    PutSApp
    b_call  _GetKey
    jr  F_ModeA_9_Activate
F_ModeA_9_Help_2:    
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Keys
    call    PutSApp
    b_call  _GetKey
    jr  F_ModeA_9_Activate
F_ModeA_9_Help_3:    
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Features
    call    PutSApp
    b_call  _GetKey
    jr  F_ModeA_9_Activate
F_ModeA_9_Help_4:    
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Contact
    call    PutSApp
    b_call  _GetKey
    jp  F_ModeA_9_Activate       
;Bytes:96

;-----------------------------------------------------------------------------------------------------------------------
;Mode 2-5 together
;----------------------------------------------------------------------------------------------------------------------- 
F_Mode_2_5_Determinate_Cursor_Position:
;B=0    -> Exit button
;B=1    -> Maximate window button
;B=4    -> Iniciar button
;B=3    -> Close window button
;B=4    -> Minimizate window button
;B=5    -> Proprietes window button
;B=11   -> Icone 1
;B=12   -> Icone 2
;B=13   -> Icone 3
;B=14   -> Icone 4
;B=15   -> Icone 5
;B=21   -> Icone 6
;B=22   -> Icone 7
;B=23   -> Icone 8
;B=24   -> Icone 9
;B=25   -> Icone 10
;B=0ffh -> Indeterminate position

;See the position of "Iniciar"
    ld  hl,(Apontador_AppVar_Utiliz)    \   inc hl  \   ld  a,(hl)
    cp  2d  \   jr  z,F_Mode_2_5_Determinate_Cursor_Position_2
    cp  3d  \   jr  z,F_Mode_2_5_Determinate_Cursor_Position_3
    cp  4d  \   jr  z,F_Mode_2_5_Determinate_Cursor_Position_4
F_Mode_2_5_Determinate_Cursor_Position_1:
    ld  a,(YPos_Rato)
    cp  7d  \   jr  c,F_Mode_2_5_Determinate_Cursor_Position_Window_1
    cp  58d \   jr  c,F_Mode_2_5_Determinate_Cursor_Position_Icon
    jr  F_Mode_2_5_Determinate_Cursor_Position_Iniciar_1
F_Mode_2_5_Determinate_Cursor_Position_2:
    ld  a,(YPos_Rato)
    cp  58d \   jr  nc,F_Mode_2_5_Determinate_Cursor_Position_Window_1
    cp  7d  \   jr  nc,F_Mode_2_5_Determinate_Cursor_Position_Icon
    jr  F_Mode_2_5_Determinate_Cursor_Position_Iniciar_1
F_Mode_2_5_Determinate_Cursor_Position_3:
    ld  a,(XPos_Rato)
    cp  89d \   jr  nc,F_Mode_2_5_Determinate_Cursor_Position_Window_2
    cp  7d  \   jr  nc,F_Mode_2_5_Determinate_Cursor_Position_Icon    
    jr  F_Mode_2_5_Determinate_Cursor_Position_Iniciar_2
F_Mode_2_5_Determinate_Cursor_Position_4:
    ld  a,(XPos_Rato)
    cp  7d  \   jr  c,F_Mode_2_5_Determinate_Cursor_Position_Window_2
    cp  89d \   jr  c,F_Mode_2_5_Determinate_Cursor_Position_Icon
F_Mode_2_5_Determinate_Cursor_Position_Iniciar_2:
    ld  a,(YPos_Rato)
    ld  b,0 \   cp  20d \   ret c
    inc b   \   cp  34d \   ret nc
    inc b
    ret
F_Mode_2_5_Determinate_Cursor_Position_Iniciar_1:
    ld  a,(XPos_Rato)
    ld  b,0 \   cp  70d \   ret nc
    inc b   \   cp  30d \   ret c
    inc b
    ret
F_Mode_2_5_Determinate_Cursor_Position_Window_1:
    ld  a,(XPos_Rato)
    ld  b,3d    \   cp  86d \   ret nc
    inc b       \   cp  78d \   ret nc
    inc b
    ret
F_Mode_2_5_Determinate_Cursor_Position_Window_2:
    ld  a,(YPos_Rato)
    ld  b,3 \   cp  7d  \   ret c
    inc b   \   cp  15  \   ret c
    inc b
    ret       
F_Mode_2_5_Determinate_Cursor_Position_Icon:
    ld  a,(YPos_Rato)
    cp  34d \   jr  nc,F_Mode_2_5_Determinate_Cursor_Position_Icon_Up
    cp  30d \   jr  c,F_Mode_2_5_Determinate_Cursor_Position_Icon_Down
    ld  b,0ffh
    ret
F_Mode_2_5_Determinate_Cursor_Position_Icon_Up:
    ld  a,(YPos_Rato)   \   ld  b,0ffh  \   cp  55d \   ret nc
    ld  a,(XPos_Rato)
    cp  6d  \   ret c   \   cp  90d \   ret nc
    cp  73d \   ret z   \   cp  56d \   ret z
    cp  39d \   ret z   \   cp  22d \   ret z
    ld  b,15d   \   cp  74d \   ret nc
    dec b       \   cp  57d \   ret nc
    dec b       \   cp  40d \   ret nc
    dec b       \   cp  23d \   ret nc
    dec b       \   cp  6d  \   ret nc
    ld  b,0ffh
    ret
F_Mode_2_5_Determinate_Cursor_Position_Icon_Down:
    ld  a,(YPos_Rato)   \   ld  b,0ffh  \   cp  9d  \   ret c
    ld  a,(XPos_Rato)
    cp  6d  \   ret c   \   cp  90d \   ret nc
    cp  73d \   ret z   \   cp  56d \   ret z
    cp  39d \   ret z   \   cp  22d \   ret z
    ld  b,25d   \   cp  74d \   ret nc
    dec b       \   cp  57d \   ret nc
    dec b       \   cp  40d \   ret nc
    dec b       \   cp  23d \   ret nc
    dec b       \   cp  6d  \   ret nc
    ld  b,0ffh
    ret 
;Bytes:222
;---------------------------------------------------------
F_Mode_2_5_Select_Deselect_Icon:
;Prepare coordenates to select/deselect
    ld  de,F_Mode_2_5_Select_Deselect_Icon_Execute
    push    de
    ld  h,33d
    ld  l,5d    \   cp  21d \   ret z
    ld  l,22d   \   cp  22d \   ret z
    ld  l,39d   \   cp  23d \   ret z
    ld  l,56d   \   cp  24d \   ret z
    ld  l,73d   \   cp  25d \   ret z
    ld  h,8d
    ld  l,5d    \   cp  11d \   ret z
    ld  l,22d   \   cp  12d \   ret z
    ld  l,39d   \   cp  13d \   ret z
    ld  l,56d   \   cp  14d \   ret z
    ld  l,73d   \   cp  15d \   ret z
    pop de
    ret
F_Mode_2_5_Select_Deselect_Icon_Execute:
;Execute Select/Deselect
    push    hl
    pop     de
    ld  a,17d   \   add a,e \   ld  e,a
    ld  a,21d   \   add a,d \   ld  d,a
    res plotLoc,(IY+plotFlags)
    push    hl
    push    de
    ld  hl,saveSScreen
    ld  de,OP1+2
    ld  bc,200d
    ldir
    pop de
    pop hl
    b_call  _InvertRect
    ld  de,saveSScreen
    ld  hl,OP1+2
    ld  bc,200d
    ldir
    ret
;Bytes:103    
;---------------------------------------------------------
F_Mode_2_5_Select_Icon:
    push    bc              ;------------------------------------------->> Save XX, 0021
    ld  a,(Icone_Selecionado)   \   call    F_Mode_2_5_Select_Deselect_Icon  
    pop     bc              ;------------------------------------------->> Load XX, 0021
    push    bc              ;------------------------------------------->> Save XX, 0022
    call    F_Mode_2_5_Find_Icon
    ld  a,c
    pop     bc              ;------------------------------------------->> Load XX, 0022
    cp  0   \   ret z
    ld  a,b \   ld  (Icone_Selecionado),a
    call    F_Mode_2_5_Select_Deselect_Icon
    ret
F_Mode_2_5_Find_Icon:
    ld  a,b \   ld  c,1d
    ld  hl,F_Mode_2_5_Find_Icon_Correct
    push    hl
    ld  de,2d
    ld  hl,Matriz_Amb_Icone_1    \   cp  11d \   ret z
    add hl,de   \   cp  12d \   ret z
    add hl,de   \   cp  13d \   ret z
    add hl,de   \   cp  14d \   ret z
    add hl,de   \   cp  15d \   ret z
    add hl,de   \   cp  21d \   ret z
    add hl,de   \   cp  22d \   ret z
    add hl,de   \   cp  23d \   ret z
    add hl,de   \   cp  24d \   ret z
    add hl,de   \   cp  25d \   ret z
F_Mode_2_5_Find_Transition:    
    ld  c,1d    \   cp  0d  \   ret nz
    dec c       \   xor a
    ld  (Icone_Selecionado),a
    ret
F_Mode_2_5_Find_Icon_Correct:
    ld  a,(hl)
    jr  F_Mode_2_5_Find_Transition   
    
;Bytes:82
;---------------------------------------------------------    
F_Mode_2_5_Alpha_Press_Execute:
    call    F_Mode_2_5_Determinate_Cursor_Position
    ld  a,b
    push    af  \   ld  hl,F_Mode_2_5_Insert_Image_Proprietes_Alpha
    push    hl  \   ld  hl,I_Propriedades_Alpha
    ld  d,32
    ld  e,1     \   cp  11d \   ret z
    ld  e,13    \   cp  12d \   ret z
    ld  e,25    \   cp  13d \   ret z
    ld  e,36    \   cp  14d \   ret z
    ld  e,46    \   cp  15d \   ret z
    ld  d,24
    ld  e,1     \   cp  21d \   ret z
    ld  e,13    \   cp  22d \   ret z
    ld  e,25    \   cp  23d \   ret z
    ld  e,36    \   cp  24d \   ret z
    ld  e,46    \   cp  25d \   ret z
    pop hl      \   pop af
F_Mode_2_5_Test_Mode:    
    ld  a,(Alpha)   \   cp  1   \   ret nz
F_Modo_2_5_Insert_Image_Create_Paste_Alpha:
    ld  hl,I_Criar_Pastas_Alpha
    ld  de,28*256+25
    push    de
    ld  de,OP1+2
    ld  bc,44d
    ldir
    ld  hl,OP1+2
    pop de    
    set plotLoc,(IY+plotFlags)
    b_call  _DisplayImage
    ld  a,1d    \   ld  (Alpha_Escolha),a
    jr  F_Mode_2_5_Alpha_Cursor
F_Mode_2_5_Alpha_Confirm_Icon:
    ld  a,(hl)
    jr  F_Mode_2_5_Insert_Image_Proprietes_Alpha_Transition
F_Mode_2_5_Insert_Image_Proprietes_Alpha:
    push    de
    push    hl
    ld  hl,F_Mode_2_5_Alpha_Confirm_Icon
    push    hl
    ld  hl,Matriz_Amb_Icone_1   \   ld  de,2d   \   cp  11d \   ret z
    add hl,de   \   cp  12d \   ret z
    add hl,de   \   cp  13d \   ret z
    add hl,de   \   cp  14d \   ret z
    add hl,de   \   cp  15d \   ret z
    add hl,de   \   cp  21d \   ret z
    add hl,de   \   cp  22d \   ret z
    add hl,de   \   cp  23d \   ret z
    add hl,de   \   cp  24d \   ret z
    add hl,de   \   cp  25d \   ret z
F_Mode_2_5_Insert_Image_Proprietes_Alpha_Transition:
    pop hl
    pop de
    ld  b,a \   pop af  \   ld  c,a \   ld  a,b
    cp  0   \   jr  z,F_Mode_2_5_Test_Mode
    ld  a,c
    push    af
    push    de
    ld  de,OP1+2
    ld  bc,44d
    ldir
    ld  hl,OP1+2
    pop de
    set plotLoc,(IY+plotFlags)
    b_call  _DisplayImage
    ld  a,2d    \   ld  (Alpha_Escolha),a
F_Mode_2_5_Alpha_Cursor:
    call    Rato_Windows
    cp  1d  \   jr  nz,F_Mode_2_5_Alpha_Cursor
F_Mode_2_5_Alpha_Cursor_Activate:
    ld  a,(Alpha_Escolha)
    cp  2   \   jp  z,F_Mode_2_5_Alpha_Cursor_Test_2
F_Mode_2_5_Alpha_Cursor_Test_1:
    ld  a,(YPos_Rato)   \   cp  28d \   ret c   \   cp  35d \   ret nc
    ld  a,(XPos_Rato)   \   cp  27d \   ret c   \   cp  71d \   ret nc
F_Mode_2_5_Create_Paste:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_CP_Nome
    call    PutSApp
    ld  hl,(Apontador_AppVar_Utiliz)
    ld  de,97d
    add hl,de
    ld  b,100d
    call    F_Mode_2_5_Find_Space
    ld  de,Matriz_Amb_Icone_1    \   ld  c,1    \   ld  b,10d
    call    F_Mode_2_5_Find_Position
    ld  a,(Janela_Actual+1) \   ld  (hl),a  \   inc hl
    ld  a,(Janela_Actual)   \   ld  (hl),a  \   inc hl
    ld  a,c     \   ld  (hl),a  \   inc hl
    ld  a,1d    \   ld  (hl),a  \   inc hl
    ld  b,4d
    call    Pedir_Texto_Escrever_Pequeno
    xor a
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a  \   inc hl
    ld  (hl),a
    ret
F_Mode_2_5_Find_Space:
    ld  a,(hl)  \   cp  0   \   ret z
    ld  de,20d
    add hl,de
    djnz    F_Mode_2_5_Find_Space
    pop hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_5
    call    PutSApp
    b_call  _GetKey
    ret
F_Mode_2_5_Find_Position    
    ld  a,(de)  \   cp  0   \   ret z
    inc de      \   inc de  \   inc c
    djnz  F_Mode_2_5_Find_Position
    pop hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_6
    call    PutSApp
    b_call  _GetKey
    ret
;Reduzir esta parte...    
F_Mode_2_5_Alpha_Cursor_Test_2:    
    pop af  \   push    af
    ld  hl,F_Mode_2_5_Alpha_Cursor_Exit \   push    hl
    cp  12d \   jr  z,F_Mode_2_5_Alpha_Test_2_2
    cp  13d \   jr  z,F_Mode_2_5_Alpha_Test_2_3
    cp  14d \   jr  z,F_Mode_2_5_Alpha_Test_2_4
    cp  15d \   jr  z,F_Mode_2_5_Alpha_Test_2_5
    cp  21d \   jp  z,F_Mode_2_5_Alpha_Test_2_6
    cp  22d \   jp  z,F_Mode_2_5_Alpha_Test_2_7
    cp  23d \   jp  z,F_Mode_2_5_Alpha_Test_2_8
    cp  24d \   jp  z,F_Mode_2_5_Alpha_Test_2_9
    ld  a,(Alpha)   \   cp  1   \   ret z
    cp  11d \   jr  z,F_Mode_2_5_Alpha_Test_2_1
    cp  25d \   jp  z,F_Mode_2_5_Alpha_Test_2_10
    ret
F_Mode_2_5_Alpha_Test_2_1:
    ld  a,(YPos_Rato)   \   cp  31d \   ret nc  \   cp  25d \   ret c
    ld  a,(XPos_Rato)   \   cp  3d  \   ret c   \   cp  47d \   ret nc
    pop hl
    jp  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_2:
    ld  a,(YPos_Rato)   \   cp  31d \   ret nc  \   cp  25d \   ret c
    ld  a,(XPos_Rato)   \   cp  15d \   ret c   \   cp  47d \   ret nc    
    pop hl
    jp  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_3:
    ld  a,(YPos_Rato)   \   cp  31d \   ret nc  \   cp  25d \   ret c
    ld  a,(XPos_Rato)   \   cp  27d \   ret c   \   cp  71d \   ret nc
    pop hl
    jp  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_4:
    ld  a,(YPos_Rato)   \   cp  31d \   ret nc  \   cp  25d \   ret c
    ld  a,(XPos_Rato)   \   cp  38d \   ret c   \   cp  82d \   ret nc
    pop hl
    jp  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_5:
    ld  a,(YPos_Rato)   \   cp  31d \   ret nc  \   cp  25d \   ret c
    ld  a,(XPos_Rato)   \   cp  48d \   ret c   \   cp  92d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_6:    
    ld  a,(YPos_Rato)   \   cp  39d \   ret nc  \   cp  33d \   ret c
    ld  a,(XPos_Rato)   \   cp  3d  \   ret c   \   cp  47d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_7:        
    ld  a,(YPos_Rato)   \   cp  39d \   ret nc  \   cp  33d \   ret c
    ld  a,(XPos_Rato)   \   cp  15d \   ret c   \   cp  59d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_8:
    ld  a,(YPos_Rato)   \   cp  39d \   ret nc  \   cp  33d \   ret c
    ld  a,(XPos_Rato)   \   cp  27d \   ret c   \   cp  71d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_9:
    ld  a,(YPos_Rato)   \   cp  39d \   ret nc  \   cp  33d \   ret c
    ld  a,(XPos_Rato)   \   cp  38d \   ret c   \   cp  82d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Alpha_Test_2_10    
    ld  a,(YPos_Rato)   \   cp  39d \   ret nc  \   cp  33d \   ret c
    ld  a,(XPos_Rato)   \   cp  48d \   ret c   \   cp  92d \   ret nc
    pop hl
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
;------------------------------------------------    
F_Mode_2_5_Alpha_Cursor_Exit:
    pop af
    ret
F_Mode_2_5_Alpha_Proprietes_Icons:        
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Propriedades
    call    PutSApp
    b_call  _GetKey
    cp  k1  \   jr  z,F_Mode_2_5_Erase_Paste
    cp  k2  \   jr  z,F_Mode_2_5_Change_Name_Paste
    cp  k3  \   jr  z,F_Mode_2_5_Alpha_Cursor_Exit
    jr  F_Mode_2_5_Alpha_Proprietes_Icons
F_Mode_2_5_Change_Name_Paste:
    pop af
    ld  hl,F_Mode_2_5_Change_Name_Paste_Execute
    push    hl
F_Mode_2_5_Share_Change_Paste_Erase_Paste:     
    ld  hl,Matriz_Amb_Icone_1   \   ld  de,2d   \   cp  11d \   ret z   
    add hl,de   \   cp  12d \   ret z
    add hl,de   \   cp  13d \   ret z
    add hl,de   \   cp  14d \   ret z
    add hl,de   \   cp  15d \   ret z
    add hl,de   \   cp  21d \   ret z
    add hl,de   \   cp  22d \   ret z
    add hl,de   \   cp  23d \   ret z
    add hl,de   \   cp  24d \   ret z
    add hl,de   \   cp  25d \   ret z
    pop hl
    ret
F_Mode_2_5_Change_Name_Paste_Execute:    
    ld  a,(hl)  \   ld  b,a \   inc hl
    ld  a,(hl)  \   ld  h,b \   ld  l,a
    inc hl      \   inc hl
    inc hl      \   inc hl
    push    hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_CP_Nome
    call    PutSApp
    pop hl
    ld  b,4d
    call    Pedir_Texto_Escrever_Pequeno
    ret    
F_Mode_2_5_Erase_Paste:
    pop af
    ld  hl,F_Mode_2_5_Erase_Paste_Execute
    push    hl
    jr  F_Mode_2_5_Share_Change_Paste_Erase_Paste
F_Mode_2_5_Erase_Paste_Execute:
    ld  a,(hl)  \   ld  b,a \   inc hl
    ld  a,(hl)  \   ld  h,b \   ld  l,a
    push    hl
    ld  hl,Matriz_Amb_Icone_1   \   ld  b,10d   \   xor a
    call    F_Mode_2_5_Find_Pastes_Inside
    pop hl
    ld  a,b
    cp  0   \   jr  nz,F_Mode_2_5_Show_Error_Pastes_Inside
F_Mode_2_5_Erase_Paste_Menu:    
    push    hl
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Certeza
    call    PutSApp
    b_call  _GetKey
    pop hl
    cp  kLog    \   ret z
    cp  kLn     \   jr  nz,F_Mode_2_5_Erase_Paste_Menu
    ld  b,19d   \   xor a
F_Mode_2_5_Erase_Paste_Execute_Yes:
    ld  (hl),a
    inc hl
    djnz    F_Mode_2_5_Erase_Paste_Execute_Yes
    ret
F_Mode_2_5_Find_Pastes_Inside:
    ld  (hl),a
    inc hl  \   inc hl
    djnz    F_Mode_2_5_Find_Pastes_Inside
    call    Procurar_Icones
    ld  hl,Matriz_Amb_Icone_1
    ld  b,10d
F_Mode_2_5_Find_Pastes_Inside_Execute:
    ld  a,(hl)  \   cp  0   \   ret nz
    inc hl      \   inc hl
    djnz    F_Mode_2_5_Find_Pastes_Inside_Execute
    ret
F_Mode_2_5_Show_Error_Pastes_Inside:
    b_call  _ClrScrnFull
    xor a
    ld  (curCol),a
    ld  (curRow),a
    ld  hl,T_Erro_S_Pastas
    call    PutSApp
    b_call  _GetKey
    ret
;Bytes:752
;Nota: Inda falta acabar umas cenas que esto marcadas    
;---------------------------------------------------------
F_Mode_2_5_Refresh_Matriz:;
;Search, and prepare HL to enter the icon if finded in plotSScreen buffer
    push    hl  \   push    bc  ;------------------------------------------->> Save XX, 0005,XX,0006  
    ld  a,(hl)  \   cp  0   \   call    nz,F_Mode_2_5_Transmit_Bytes_To_Matriz
    pop     bc  \   pop     hl  ;------------------------------------------->> Load XX, 0006,XX,0005  
    inc hl      \   inc hl
    djnz    F_Mode_2_5_Refresh_Matriz
    ret
F_Mode_2_5_Transmit_Bytes_To_Matriz:
;Inser icon in plotSScreen buffer 
    ld  d,a     \   inc hl
    ld  a,(hl)  \   ld  e,a
    inc de
    inc de
    ld  a,(de)  \   ld  b,a
    push    bc              ;------------------------------------------->> Save XX, 0007
    inc de
    ld  a,(de)
    push    de              ;------------------------------------------->> Save XX, 0008
    call    F_Mode_2_Insert_Image_Icon
    ld  de,Matriz_II_Imagem
    ld  bc,34d
    ldir
    pop hl                  ;------------------------------------------->> Load XX, 0008
    inc hl
    ld  bc,4d
    ldir
    pop bc                  ;------------------------------------------->> Load XX, 0007
    call    Inserir_Icone
    xor a
    ret
;Bytes:52
;----------------------------------------------------------



#include    "Textos.asm"                                    ;Bytes:1149
#include    "Imagens.asm"                                   ;Bytes:2030
#include    "Variaveis.asm"                                 ;Bytes:2
#include    "SRotina_Sair.asm"                              ;Bytes:18
#include    "SRotina_PutSS.asm"                             ;Bytes:40
#include    "SRotina_PutCC.asm"                             ;Bytes:109
#include    "SRotina_PutSApp.asm"                           ;Bytes:6
#include    "SRotina_Por_Rato.asm"                          ;Bytes:27
#include    "SRotina_MenuMaker.asm"                         ;Bytes:827      *Pode ser reduzido o nr d bytes.
#include    "SRotina_LogOn_FrtzOS.asm"                      ;Bytes:322
#include    "SRotina_Rato_Windows.asm"                      ;Bytes:383
#include    "SRotina_Inserir_Icone.asm"                     ;Bytes:123
#include    "SRotina_Desenhar_Janela.asm"                   ;Bytes:70
#include    "SRotina_Procurar_Icones.asm"                   ;Bytes:92
#include    "SRotina_Arquivar_AppVars.asm"                  ;Bytes:62
#include    "SRotina_Tecla_Presionada.asm"                  ;Bytes:509
#include    "SRotina_Criar_AppVar_Geral.asm"                ;Bytes:243
#include    "SRotina_Criar_AppVar_Utiliz.asm"               ;Bytes:55
#include    "SRotina_Pedir_Texto_Escrever.asm"              ;Bytes:68
#include    "SRotina_Desenhar_Barra_De_Ferramentas.asm"     ;Bytes:85
;Retire one include


;Bytes: 4757  -> Parciais           -Routine principal 
;------------
;Bytes: 4757  -> Parciais           -Sub-routines, dados
;------------
;Bytes: 3685  -> Parciais           -Text and Images
;------------   
;Bytes: 1000  -> Parciais           -ROM Call 
;------------
;Bytes: 1000  -> Compensasao        -Compensation to the assembler error
;------------
;Total: 15559                       -Total
;------------
;Livre: 1187                        -Free
    

.end
